break out default variables into their own file: defaultenv
[monkeysphere.git] / tests / basic
index ad72a2282dbd8e84af3b92daac70e337aae04b11..72771687a8040db419fa76b78dc4af8af2a7185f 100755 (executable)
 
 # these tests should all be able to run as a non-privileged user.
 
+# put all the test output to stdout
+exec 2>&1
 # all subcommands in this script should complete without failure:
 set -e
 # piped commands should return the code of the first non-zero return
 set -o pipefail
 
+# make sure the TESTDIR is an absolute path, not a relative one.
+export TESTDIR=$(cd $(dirname "$0") && pwd)
+
+source "$TESTDIR"/common
+
 ## make sure that the right tools are installed to run the test.  the
 ## test has *more* requirements than plain ol' monkeysphere:
 which socat >/dev/null || { echo "You must have socat installed to run this test." ; exit 1; }
 
+perl -MCrypt::OpenSSL::RSA -e 1 2>/dev/null || { echo "You must have the perl module Crypt::OpenSSL::RSA installed to run this test.  
+On debian-derived systems, you can set this up with:
+  apt-get install libcrypt-openssl-rsa-perl" ; exit 1; }
+
+
+perl -MDigest::SHA1 -e 1 2>/dev/null || { echo "You must have the perl module Digest::SHA1 installed to run this test.  
+On debian-derived systems, you can set this up with:
+  apt-get install libdigest-sha1-perl" ; exit 1; }
+
 ## FIXME: other checks?
 
 ######################################################################
@@ -28,12 +44,15 @@ which socat >/dev/null || { echo "You must have socat installed to run this test
 
 # gpg command for test admin user
 gpgadmin() {
-    GNUPGHOME="$TEMPDIR"/admin/.gnupg gpg "$@"
+    chmod 0700 "$TEMPDIR"/admin
+    GNUPGHOME="$TEMPDIR"/admin/.gnupg gpg --no-tty "$@"
 }
 
 # test ssh connection
 # first argument is expected return code from ssh connection
 ssh_test() {
+    local RETURN=0
+
     umask 0077
 
     CODE=${1:-0}
@@ -48,20 +67,16 @@ ssh_test() {
        sleep 1
     done
 
-    set +e
-
     # make a client connection to the socket
     echo "##### starting ssh client..."
     ssh-agent bash -c \
-       "monkeysphere subkey-to-ssh-agent && ssh -F $TEMPDIR/testuser/.ssh/config testhost true"
-    RETURN="$?"
+       "monkeysphere subkey-to-ssh-agent && ssh -F $TEMPDIR/testuser/.ssh/config testhost true" \
+       || RETURN="$?"
 
     # kill the sshd process if it's still running
     kill "$SSHD_PID"
     SSHD_PID=
 
-    set -e
-
     echo "##### return $RETURN"
     if [ "$RETURN" = "$CODE" ] ; then
        echo "##### ssh connection test returned as desired"
@@ -72,34 +87,6 @@ ssh_test() {
     fi
 }
 
-failed_cleanup() {
-    # FIXME: can we be more verbose here?
-    echo 'FAILED!'
-    read -p "press enter to cleanup and remove tmp:"
-
-    cleanup
-}
-
-get_gpg_prng_arg() {
-    if (gpg --quick-random --version >/dev/null 2>&1) ; then
-       echo quick-random
-    elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
-       echo debug-quick-random
-    fi
-}
-
-cleanup() {
-    echo "### removing temp dir..."
-    rm -rf "$TEMPDIR"
-
-    if [ "$SSHD_PID" ] ; then
-       echo "### killing off lingering sshd..."
-       kill "$SSHD_PID"
-    fi
-
-    wait
-}
-
 SSHD_PID=
 
 ## setup trap
@@ -112,26 +99,35 @@ trap failed_cleanup EXIT
 ## set up some variables to ensure that we're operating strictly in
 ## the tests, not system-wide:
 
-export TESTDIR=$(dirname "$0")
+# set up temp dir
+
+# NOTE: /tmp can not be used as the temp dir here, since the
+# permissions on /tmp are usually such that they will not pass the
+# monkeysphere/ssh path permission checking.  If you need to use a
+# different location than the current source, please set $TMPDIR
+# somewhere with tighter permissions.
 
-# make temp dir
-TEMPDIR="$TESTDIR"/tmp
-if [ -e "$TEMPDIR" ] ; then
-    echo "tempdir '$TEMPDIR' already exists."
-    exit 1
-fi
+mkdir -p "$TESTDIR"/tmp
+TEMPDIR=$(mktemp -d "${TMPDIR:-$TESTDIR/tmp}/monkeyspheretest.XXXXXXX")
 
 # Use the local copy of executables first, instead of system ones.
 # This should help us test without installing.
-export PATH="$TESTDIR"/../src:"$TESTDIR"/../src/keytrans:"$PATH"
+export PATH="$TESTDIR"/../src:"$PATH"
 
 export MONKEYSPHERE_SYSDATADIR="$TEMPDIR"
 export MONKEYSPHERE_SYSCONFIGDIR="$TEMPDIR"
 export MONKEYSPHERE_SYSSHAREDIR="$TESTDIR"/../src/share
 export MONKEYSPHERE_MONKEYSPHERE_USER=$(whoami)
+
 export MONKEYSPHERE_CHECK_KEYSERVER=false
+# example.org does not respond to the HKP port, so this should cause
+# any keyserver connection attempts that do happen (they shouldn't!)
+# to hang, so we'll notice them:
+export MONKEYSPHERE_KEYSERVER=example.org
+
 export MONKEYSPHERE_LOG_LEVEL=DEBUG
 export MONKEYSPHERE_CORE_KEYLENGTH=1024
+export MONKEYSPHERE_PROMPT=false
 
 export SSHD_CONFIG="$TEMPDIR"/sshd_config
 export SOCKET="$TEMPDIR"/ssh-socket
@@ -142,54 +138,19 @@ export SOCKET="$TEMPDIR"/ssh-socket
 # *anything* with any running X11 session.
 export DISPLAY=monkeys
 
-######################################################################
-### TEST KEY CONVERSION
-
-mkdir -p "$TEMPDIR"
-
-echo "##################################################"
-echo "### test key conversion..."
-export GNUPGHOME="$TEMPDIR"
-# generate a key
-gpg --batch --quick-random --gen-key <<EOF
-Key-Type: RSA
-Key-Length: 1024
-Key-Usage: sign
-Name-Real: testtest
-Expire-Date: 0
-
-%commit
-%echo done
-EOF
-# get the the key timestamp
-timestamp=$(gpg --list-key --with-colons --fixed-list-mode | \
-    grep ^pub: | cut -d: -f6)
-# export the key to a file
-gpg --export-secret-key | openpgp2ssh > \
-    "$TEMPDIR"/test.pem
-# reconvert key, and compare to key in gpg keyring
-diff -u \
-    <(gpg --export-secret-key | hd) \
-    <(PEM2OPENPGP_USAGE_FLAGS=sign,certify \
-    PEM2OPENPGP_TIMESTAMP="$timestamp" pem2openpgp testtest < \
-    "$TEMPDIR"/test.pem | hd )
-
-# clear out the temp dir
-rm -rf "$TEMPDIR"
-mkdir -p "$TEMPDIR"
 
 ######################################################################
 ### CONFIGURE ENVIRONMENTS
 
 # copy in admin and testuser home to tmp
+echo
 echo "##################################################"
-echo "### copying admin and testuser homes..."
-cp -a "$TESTDIR"/home/admin "$TEMPDIR"/
+echo "### configuring testuser home..."
 cp -a "$TESTDIR"/home/testuser "$TEMPDIR"/
-
 # set up environment for testuser
 export TESTHOME="$TEMPDIR"/testuser
 export GNUPGHOME="$TESTHOME"/.gnupg
+chmod 0700 "$GNUPGHOME"
 export SSH_ASKPASS="$TESTHOME"/.ssh/askpass
 export MONKEYSPHERE_HOME="$TESTHOME"/.monkeysphere
 cat <<EOF >> "$TESTHOME"/.ssh/config
@@ -202,53 +163,52 @@ KNOWN_HOSTS=$TESTHOME/.ssh/known_hosts
 EOF
 get_gpg_prng_arg >> "$GNUPGHOME"/gpg.conf
 
+echo
+echo "##################################################"
+echo "### configuring admin home..."
+cp -a "$TESTDIR"/home/admin "$TEMPDIR"/
+
 # set up sshd
+echo
 echo "##################################################"
 echo "### configuring sshd..."
 cp "$TESTDIR"/etc/ssh/sshd_config "$SSHD_CONFIG"
 # write the sshd_config
 cat <<EOF >> "$SSHD_CONFIG"
 HostKey ${MONKEYSPHERE_SYSDATADIR}/ssh_host_rsa_key
-AuthorizedKeysFile ${MONKEYSPHERE_SYSDATADIR}/authentication/authorized_keys/%u
+AuthorizedKeysFile ${MONKEYSPHERE_SYSDATADIR}/authorized_keys/%u
 EOF
 
 
 ######################################################################
 ### SERVER HOST SETUP
 
-# create a new host key
-echo "##################################################"
-echo "### testing host key generation..."
-mkdir -p -m 750 "$MONKEYSPHERE_SYSDATADIR"/host
-# add gpg.conf with quick-random
-get_gpg_prng_arg >> "$MONKEYSPHERE_SYSCONFIGDIR"/host/gpg.conf
-echo | monkeysphere-host expert gen-key --length 1024 testhost
-
-# remove the host home for the next test
-rm -rf "$MONKEYSPHERE_SYSCONFIGDIR"/host
-
 # import host key
+echo
 echo "##################################################"
-echo "### testing host key importing..."
+echo "### import host key..."
 ssh-keygen -b 1024 -t rsa -N '' -f "$TEMPDIR"/ssh_host_rsa_key
-monkeysphere-host expert import-key testhost < "$TEMPDIR"/ssh_host_rsa_key
+monkeysphere-host import-key "$TEMPDIR"/ssh_host_rsa_key testhost
+
+echo
+echo "##################################################"
+echo "### getting host key fingerprint..."
+HOSTKEYID=$( monkeysphere-host show-key | grep '^OpenPGP fingerprint: ' | cut -f3 -d\  )
+echo "$HOSTKEYID"
 
 # change host key expiration
+echo
 echo "##################################################"
 echo "### setting host key expiration..."
 monkeysphere-host set-expire 1
-monkeysphere-host show-key
 # FIXME: how do we check that the expiration has really been set?
 
-echo "##################################################"
-echo "### getting host key fingerprint..."
-HOSTKEYID=$( monkeysphere-host show-key | grep '^OpenPGP fingerprint: ' | cut -f3 -d\  )
-
 # certify host key with the "Admin's Key".
 # (this would normally be done via keyservers)
+echo
 echo "##################################################"
 echo "### certifying server host key..."
-GNUPGHOME="$MONKEYSPHERE_SYSCONFIGDIR"/host gpg --armor --export "$HOSTKEYID" | gpgadmin --import
+< "$MONKEYSPHERE_SYSCONFIGDIR"/ssh_host_rsa_key.pub.gpg gpgadmin --import
 echo y | gpgadmin --command-fd 0 --sign-key "$HOSTKEYID"
 
 # FIXME: add revoker?
@@ -263,62 +223,76 @@ echo y | gpgadmin --command-fd 0 --sign-key "$HOSTKEYID"
 ### SERVER AUTHENTICATION SETUP
 
 # set up monkeysphere authentication
+echo
 echo "##################################################"
 echo "### setup monkeysphere authentication..."
 cp "$TESTDIR"/etc/monkeysphere/monkeysphere-authentication.conf "$TEMPDIR"/
 cat <<EOF >> "$TEMPDIR"/monkeysphere-authentication.conf
-AUTHORIZED_USER_IDS="$MONKEYSPHERE_HOME/authentication/authorized_user_ids"
+AUTHORIZED_USER_IDS="$MONKEYSPHERE_HOME/authorized_user_ids"
 EOF
 monkeysphere-authentication setup
 get_gpg_prng_arg >> "$MONKEYSPHERE_SYSDATADIR"/authentication/sphere/gpg.conf
 
 # add admin as identity certifier for testhost
+echo
 echo "##################################################"
 echo "### adding admin as certifier..."
-echo y | monkeysphere-authentication add-id-certifier "$TEMPDIR"/admin/.gnupg/pubkey.gpg
+monkeysphere-authentication add-id-certifier "$TEMPDIR"/admin/.gnupg/pubkey.gpg
 
-# FIXME: should we run "diagnostics" here to test setup?
+echo
+echo "##################################################"
+echo "### list certifiers..."
+monkeysphere-authentication list-certifiers
 
+# FIXME: should we run "diagnostics" here to test setup?
 
 ######################################################################
 ### TESTUSER SETUP
 
 # generate an auth subkey for the test user that expires in 2 days
+echo
 echo "##################################################"
 echo "### generating key for testuser..."
-monkeysphere gen-subkey --expire 2
+monkeysphere gen-subkey
 
 # add server key to testuser keychain
+echo
 echo "##################################################"
 echo "### export server key to testuser..."
 gpgadmin --armor --export "$HOSTKEYID" | gpg --import
 
 # teach the "server" about the testuser's key
+echo
 echo "##################################################"
 echo "### export testuser key to server..."
 gpg --export testuser | monkeysphere-authentication gpg-cmd --import
 
 # update authorized_keys for user
+echo
 echo "##################################################"
 echo "### update server authorized_keys file for this testuser..."
 monkeysphere-authentication update-users $(whoami)
-
+# FIXME: this is maybe not failing properly for:
+# ms: improper group or other writability on path '/tmp'.
 
 ######################################################################
 ### TESTS
 
-# connect to test sshd, using monkeysphere-ssh-proxycommand to verify
+# connect to test sshd, using monkeysphere ssh-proxycommand to verify
 # the identity before connection.  This should work in both directions!
+echo
 echo "##################################################"
 echo "### ssh connection test for success..."
 ssh_test
 
 # remove the testuser's authorized_user_ids file, update, and make
 # sure that the ssh authentication FAILS
+echo
 echo "##################################################"
 echo "### removing testuser authorized_user_ids and updating..."
 mv "$TESTHOME"/.monkeysphere/authorized_user_ids{,.bak}
 monkeysphere-authentication update-users $(whoami)
+echo
 echo "##################################################"
 echo "### ssh connection test for server authentication denial..."
 ssh_test 255
@@ -326,35 +300,50 @@ mv "$TESTHOME"/.monkeysphere/authorized_user_ids{.bak,}
 
 # put improper permissions on authorized_user_ids file, update, and
 # make sure ssh authentication FAILS
+echo
 echo "##################################################"
 echo "### setting group writability on authorized_user_ids and updating..."
 chmod g+w "$TESTHOME"/.monkeysphere/authorized_user_ids
 monkeysphere-authentication update-users $(whoami)
+echo
 echo "##################################################"
 echo "### ssh connection test for server authentication denial..."
 ssh_test 255
 chmod g-w "$TESTHOME"/.monkeysphere/authorized_user_ids
+echo
 echo "##################################################"
 echo "### setting other writability on authorized_user_ids and updating..."
 chmod o+w "$TESTHOME"/.monkeysphere/authorized_user_ids
 monkeysphere-authentication update-users $(whoami)
+echo
 echo "##################################################"
 echo "### ssh connection test for server authentication denial..."
 ssh_test 255
 chmod o-w "$TESTHOME"/.monkeysphere/authorized_user_ids
+monkeysphere-authentication update-users $(whoami)
 
 # FIXME: addtest: remove admin as id-certifier and check ssh failure
 
 # FIXME: addtest: add hostname on host key
 # FIXME: addtest: revoke hostname on host key and check ssh failure
 
-# FIXME: addtest: revoke the host key and check ssh failure
+# addtest: revoke the host key and check ssh failure
+# test to make sure things are OK after the previous tests:
+ssh_test
+echo
+echo "##################################################"
+echo "### ssh connection test for server with revoked key..."
+# generate the revocation certificate and feed it directly to the test
+# user's keyring (we're not publishing to the keyservers)
+monkeysphere-host revoke-key | gpg --import
+ssh_test 255
 
 
 ######################################################################
 
 trap - EXIT
 
+echo
 echo "##################################################"
 echo " Monkeysphere basic tests completed successfully!"
 echo "##################################################"